exercises/docker-compose/app/config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  root to: 'pages#home'
  resources :articles

  get 'signup', to: 'users#new'
  resources :users, except: [:new]

  get 'login', to: 'sessions#new'
  post 'login', to: 'sessions#create'
  delete 'logout', to: 'sessions#destroy'

  resources :categories, except: [:destroy]
end

exercises/docker-compose/app/app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

exercises/docker-compose/app/app/models/article.rb
class Article < ApplicationRecord
  belongs_to :user
  validates :title, presence: true, length: { minimum: 3, maximum: 50 }
  validates :description, presence: true
  validates :user_id, presence: true
end

exercises/docker-compose/app/app/models/category.rb
class Category < ApplicationRecord
  validates :name,
            presence: true,
            length: { minimum: 3, maximum: 25 }
  validates_uniqueness_of :name
end

exercises/docker-compose/app/app/models/user.rb
class User < ApplicationRecord
  has_many :articles, dependent: :destroy
  before_save { self.email = email.downcase }
  validates :username,
            presence: true,
            uniqueness: { case_sensitive: false },
            length: { minimum: 3, maximum: 25 }
  VALID_EMAIL_REGEX = /\A[\w+\-.]+@[a-z\d\-]+(\.[a-z\d\-]+)*\.[a-z]+\z/i
  validates :email,
            presence: true,
            uniqueness: { case_sensitive: false },
            length: { maximum: 105 },
            format: { with: VALID_EMAIL_REGEX }
  has_secure_password
end

exercises/docker-compose/app/app/controllers/application_controller.rb
class ApplicationController < ActionController::Base

  helper_method :current_user, :logged_in?

  def current_user
    @current_user ||= User.find(session[:user_id]) if session[:user_id]
  end

  def logged_in?
    !!current_user
  end

  def require_user
    unless logged_in?
      flash[:danger] = 'You must be logged in'
      redirect_to login_path
    end
  end
end

exercises/docker-compose/app/app/controllers/articles_controller.rb
class ArticlesController < ApplicationController
  before_action :set_article, only: [:edit, :update, :destroy, :show]
  before_action :require_user, except: [:index, :show]
  before_action :require_same_user, only: [:edit, :update, :destroy]
  
  def index
    @articles = Article.paginate(page: params[:page], per_page: 5)
  end

  def new
    @article = Article.new
  end

  def show
  end

  def create
    @article = Article.new(article_params)
    @article.user = current_user
    if @article.save
      flash[:success] = 'Article was successfully created'
      redirect_to article_path(@article)
    else
      render 'new'
    end
  end

  def edit
  end

  def update
    if @article.update(article_params)
      flash[:success] = 'Article wass successfully updated'
      redirect_to article_path(@article)
    else
      render 'edit'
    end
  end

  def destroy
    @article.destroy
    flash[:danger] = 'Article was successfully deleted'
    redirect_to articles_path
  end

  private

  def article_params
    params.require(:article).permit(:title, :description)
  end

  def set_article
    @article = Article.find(params[:id])
  end

  def require_same_user
    if current_user != @article.user and !current_user.admin?
      flash[:danger] = 'You can only delete your own articles'
      redirect_to root_path
    end
  end
end

exercises/docker-compose/app/app/controllers/categories_controller.rb
class CategoriesController < ApplicationController
  before_action :require_user, except: [:index, :show]
  before_action :require_admin, except: [:index, :show]
  
  def index
    @categories = Category.paginate(page: params[:page], per_page: 5)
  end

  def new
    @category = Category.new
  end

  def show
  end

  def create
    @category = Category.new(category_params)
    if @category.save
      flash[:success] = 'Category was successfully created'
      redirect_to categories_path
    else
      render 'new'
    end
  end

  private

  def category_params
    params.require(:category).permit(:name)
  end

  def require_admin
    unless current_user.admin?
      flash[:danger] = 'This action only for admin'
      redirect_to categories_path
    end
  end
end

exercises/docker-compose/app/app/controllers/pages_controller.rb
class PagesController < ApplicationController
  def home
    redirect_to articles_path if logged_in?
  end
end

exercises/docker-compose/app/app/controllers/sessions_controller.rb
class SessionsController < ApplicationController
  def new
  end

  def create
    user = User.find_by(email: params[:session][:email].downcase)
    if user&.authenticate(params[:session][:password])
      session[:user_id] = user.id
      flash[:success] = 'You have successfully logged in'
      redirect_to user_path(user)
    else
      flash.now[:danger] = 'Incorrect login or password'
      render 'new'
    end
  end

  def destroy
    session[:user_id] = nil
    flash[:success] = 'You have successfully logged out'
    redirect_to root_path
  end
end

exercises/docker-compose/app/app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :set_user, only: [:edit, :update, :show]
  before_action :require_same_user, only: [:edit, :update, :destroy]
  before_action :require_admin, only: [:destroy]
  
  def index
    @users = User.paginate(page: params[:page], per_page: 5)
  end

  def new
    @user = User.new
  end

  def show() end

  def create
    @user = User.new(user_params)
    if @user.save
      session[:user_id] = @user.id
      flash[:success] = "Welcome to the R Blog #{@user.username}"
      redirect_to user_path(@user)
    else
      render 'new'
    end
  end

  def edit() end

  def update
    if @user.update(user_params)
      flash[:success] = 'Account was successfully updated'
      redirect_to articles_path
    else
      render 'edit'
    end
  end

  def destroy
    @user = User.find(params[:id])
    @user.destroy
    flash[:success] = "User #{@user.username} was successfully deleted"
    redirect_to action: 'index'
  end

  private

  def user_params
    params.require(:user).permit(:username, :email, :password)
  end

  def set_user
    @user = User.find(params[:id])
  end

  def require_same_user
    if current_user != @user and !current_user.admin?
      flash[:danger] = 'You can only do this with your own account'
      redirect_to root_path
    end
  end

  def require_admin
    unless current_user.admin?
      flash[:danger] = 'This action only for admin'
      redirect_to root_path
    end
  end
end

exercises/docker-compose/app/app/helpers/application_helper.rb
module ApplicationHelper
  def gravatar_for(user)
    gravatar_id = Digest::MD5::hexdigest(user.email.downcase)
    gravatar_url = "https://secure.gravatar.com/avatar/#{gravatar_id}"
    image_tag(gravatar_url, alt: user.username, class: 'card-img-top')
  end
end

exercises/docker-compose/app/app/views/articles/_form.html.erb
<%= render("shared/errors", obj: @article) %>
<%= form_for @article do |f| %>
<div class="form-group">
  <%= f.label :title %>
  <%= f.text_field :title, class: "form-control", placeholder: "Title of article", autofocus: true %>
</div>
<div class="form-group">
  <%= f.label :description %>
  <%= f.text_area :description, class: "form-control", placeholder: "Description of article" %>
</div>

<div>
  <%= f.submit class: "btn btn-primary" %>
  <%= link_to 'back to articles', articles_path, style: "margin-left: 8px" %>
</div>

<% end %>

exercises/docker-compose/app/app/views/articles/edit.html.erb
<h1>Edit existing article</h1>

<%= render 'form' %>

exercises/docker-compose/app/app/views/articles/index.html.erb
<h1 aligin="center">Articles</h1>
<div style="margin: auto; width: fit-content">
  <%= will_paginate @articles, renderer: WillPaginate::ActionView::BootstrapLinkRenderer %>
</div>
<table class="table">
  <thead>
    <tr>
      <th>
        Title
      </th>
      <th>
        Username
      </th>
      <th>
        Created
      </th>
       <th>
        Actions
      </th>
     </tr>
  </thead>
  <% @articles.each do |article| %>
  <tbody>
    <tr scope="row">
      <td><%= link_to article.title, article_path(article) %></td>
      <td>
        <%= article.user.username %>
      </td>
      <td>
        <%= time_ago_in_words(article.created_at) %>
      </td>
      <td>
        <%= link_to 'Show', article_path(article), class: "btn btn-sm btn-info" %>
        <% if (logged_in? && current_user == article.user) or current_user.admin? %>
        <%= link_to 'Edit', edit_article_path(article), class: "btn btn-sm btn-primary" %>
        <%= link_to 'Delete', article_path(article), method: :delete, data: {confirm: 'Are you sure?'}, class: "btn btn-sm btn-danger" %>
        <% end %>
      </td>
    </tr>
  </tbody>
  <% end %>
</table>
<div style="margin: auto; width: fit-content">
  <%= will_paginate @articles, renderer: WillPaginate::ActionView::BootstrapLinkRenderer %>
</div>

exercises/docker-compose/app/app/views/articles/new.html.erb
<h1>Create an article</h1>

<%= render 'form' %>

exercises/docker-compose/app/app/views/articles/show.html.erb
<h2 align="center"><%= @article.title %></h2>
<div class="well col-md-8 col-md-offset-2">
  <%= simple_format(@article.description) %>
</div>
<% if (logged_in? && current_user == @article.user) or current_user.admin? %>
<%= link_to 'edit', edit_article_path(@article), class: "btn btn-sm btn-primary" %>
<%= link_to 'delete', article_path(@article), method: "delete", class: "btn btn-sm btn-danger", data: { confirm: "Are you sure?" } %>
<% end %>
<%= link_to 'back to articles', articles_path, class: "btn btn-sm btn-success" %>

exercises/docker-compose/app/app/views/categories/index.html.erb
<h1 align="center">Categories</h1>
<div>
  <%= will_paginate @categories, renderer: WillPaginate::ActionView::BootstrapLinkRenderer %>
</div>
<ul class="listing">
  <div class="row">
    <div class="well col-md-4 col-md-offset-4">
      <% @categories.each do |category| %>
      <li class="article-title">
        <%= link_to category.name, category_path(category) %>
      </li>
      <% end %>
    </div>
  </div>
</ul>
<div>
  <%= will_paginate @categories, renderer: WillPaginate::ActionView::BootstrapLinkRenderer %>
</div>

exercises/docker-compose/app/app/views/categories/new.html.erb
<h1 align="center">Create new category</h1>
<%= render("shared/errors", obj: @category) %>
<%= form_for @category do |f| %>
<div class="form-group">
  <%= f.label :name %>
  <%= f.text_field :name, class: "form-control", placeholder: "Category name", autofocus: true %>
</div>
<div>
  <div>
    <%= f.submit(@category.new_record? ? "Create" : "Update", class: "btn btn-primary") %>
  </div>
</div>
<% end %>

exercises/docker-compose/app/app/views/layouts/_footer.html.erb
<footer class="footer-copyright text-center py-3">
  <small>
    Copyright &copy; <a href="#">Ruby</a>
  </small>
</footer>

exercises/docker-compose/app/app/views/layouts/_messages.html.erb
<div class="row">
  <div class="col-sm-10 col-sm-offset-1">
    <% flash.each do |name, msg| %>
    <div class='alert alert-<%= "#{name}" %>'>
      <a href="#" class="close" data-dismiss="alert">&#215;</a>
      <%= content_tag :div, msg, :id => "flash_#{name}" if msg.is_a?(String) %>
    </div>
    <% end %>
  </div>
</div>

exercises/docker-compose/app/app/views/layouts/_navigation.html.erb
<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <%= link_to "R Blog", root_path, class: "navbar-brand", id: "logo" %>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>
  <div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="navbar-nav mr-auto">
      <li class="nav-item">
        <%= link_to "Articles", articles_path, class: "nav-link" %>
      </li>
      <% if logged_in? %>
      <li class="nav-item">
        <%= link_to "Users", users_path, class: "nav-link" %>
      </li>
      <li class="nav-item dropdown">
        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
          Artice actions
        </a>
        <div class="dropdown-menu" aria-labelledby="navbarDropdown">
          <%= link_to "New article", new_article_path, class: "dropdown-item" %>
        </div>
      </li>
      <% end %>
    </ul>
    <% if logged_in? %>
    <%= "Admin" if current_user.admin? %>
    <%= link_to current_user.username, user_path(current_user), class: "nav-link" %>
    <%= link_to "Log out", logout_path, method: :delete, class: "nav-link" %>
    <% else %>
    <%= link_to "Log in", login_path, class: "nav-link" %>
    <%= link_to "Sign up", signup_path, class: "nav-link" %>
    <% end %>
  </div>
</nav>

exercises/docker-compose/app/app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>AlphaBlog</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>
  <body>
    <%= render 'layouts/navigation' %>
    <div class="container" style="margin-top: 32px;">
      <%= render 'layouts/messages' %>
    </div>
    <div class="container">
      <%= yield %>
    </div>
    <%= render 'layouts/footer' %>
  </body>
</html>

exercises/docker-compose/app/app/views/pages/home.html.erb
<div class="center jumbotron" style="margin-top: 16px">
  <h1>R Blog</h1>
  <%= link_to("Sign up", signup_path, class: "btn btn-primary btn-lg") unless session[:user_id] %>
</div>

exercises/docker-compose/app/app/views/shared/_errors.html.erb
<% if obj.errors.any? %>
<div class="alert alert-danger">
  <div class="alert-heading">
    <h2 class="panel-title">
      <%= pluralize(obj.errors.count, "error") %>
      prohibited this article from being saved:
    </h2>
    <div class="panel-body">
      <ul>
        <% obj.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  </div>
</div>
<% end %>

exercises/docker-compose/app/app/views/users/_form.html.erb
<%= render("shared/errors", obj: @user) %>
<%= form_for @user do |f| %>
<div class="form-group">
  <%= f.label :username %>
  <%= f.text_field :username, class: "form-control", placeholder: "Username", autofocus: true %>
</div>
<div class="form-group">
  <%= f.label :email %>
  <%= f.email_field :email, class: "form-control", placeholder: "Email" %>
</div>
<div class="form-group">
  <%= f.label :password %>
  <%= f.password_field :password, class: "form-control", placeholder: "Password" %>
</div>
<div>
  <div>
    <%= f.submit(@user.new_record? ? "Sign up" : "Update", class: "btn btn-primary") %>
  </div>
</div>

<% end %>

exercises/docker-compose/app/app/views/users/edit.html.erb
<h1 align="center">Edit your account</h1>
<%= render "form" %>

exercises/docker-compose/app/app/views/users/index.html.erb
<h1 aligin="center">Users</h1>
<div style="margin: auto; width: fit-content">
  <%= will_paginate @users, renderer: WillPaginate::ActionView::BootstrapLinkRenderer %>
</div>
<table class="table">
  <thead>
    <tr>
      <th>
        Username
      </th>
      <th>
        email
      </th>
      <th>
        Created
      </th>
      <th>
        Articles
      </th>
      <th>
        Actions
      </th>
    </tr>
  </thead>
  <% @users.each do |user| %>
  <tbody>
    <tr scope="row">
      <td><%= link_to user.username, user_path(user) %></td>
      <td>
        <%= user.email %>
      </td>
      <td>
        <%= time_ago_in_words(user.created_at) %>
      </td>
      <td>
        <%= pluralize(user.articles.count, "article") %>
      </td>
      <td>
        <%= link_to 'Show', user_path(user), class: "btn btn-sm btn-info" %>
        <% if logged_in? && current_user == user %>
        <%= link_to 'Edit', edit_user_path(user), class: "btn btn-sm btn-primary" %>
        <% end %>
        <% if current_user.admin? and !user.admin? %>
        <%= link_to 'Delete', user_path(user), method: :delete, data: {confirm: 'Are you sure?'}, class: "btn btn-sm btn-danger" %>
        <% end %>
      </td>
    </tr>
  </tbody>
  <% end %>
</table>
<div style="margin: auto; width: fit-content">
  <%= will_paginate @users, renderer: WillPaginate::ActionView::BootstrapLinkRenderer %>
</div>

exercises/docker-compose/app/app/views/users/new.html.erb
<h1 align="center">Sign up for R Blog</h1>
<%= render "form" %>

exercises/docker-compose/app/app/views/users/show.html.erb
<div class="d-flex justify-content-center">
  <div class="card text-center" style="width: 18rem;">
    <%= gravatar_for @user %>
    <div class="card-body">
      <h5 class="card-title">
        <%= @user.username %>
      </h5>
      <p class="card-text">
        <div class="list-group" id="list-tab" role="tablist">
          <% @user.articles.each do |article| %>
            <%= link_to article.title, article_path(article) %>
          <% end %>
        </div>
        <% if (logged_in? && current_user == @user) or current_user.admin? %>
        <%= link_to "Edit",
            edit_user_path(@user),
            class: "btn btn-primary", style: "margin-top: 15px;"%>
        <% end %>
      </p>
    </div>
  </div>
</div>